"use strict";
var gYaInstaller = {
__installed: true,
__lastEmActionRequestedName: "",
get isBarUninstalled() {
return this.__installed == false;
}
,
APP_ACTION_QUIT_TOPIC: "quit-application",
LASTVERSION_PREF_NAME: "yasearch.general.lastVersion",
CHECK_TOOLBAR_COLLAPSED_PREF_NAME: "yasearch.general.checkToolbarCollapsed",
startup: function YaInstaller_startup() {
OBSERVER_SERVICE.addObserver(this,this.APP_ACTION_QUIT_TOPIC,false);
this._proccessInstall();
AddonManager.addAddonListener(this);
}
,
shutdown: function YaInstaller_shutdown() {
AddonManager.removeAddonListener(this);
OBSERVER_SERVICE.removeObserver(this,this.APP_ACTION_QUIT_TOPIC);
if (this.isBarUninstalled)
this._proccessUninstall();
}
,
onAddonEvent: function YaInstaller_onAddonEvent(aEventType, aAddon, aPendingRestart) {
if (aAddon.id !== EXT_ID)
return;
switch (aEventType) {
case "onUninstalling":

case "onUpdateFinished":
gYaSearchService.setIntPref(this.CHECK_TOOLBAR_COLLAPSED_PREF_NAME,this.CHECK_GLOBAL_INSTALL_POST_CHECK);
break;
case "onOperationCancelled":
if (this.__lastEmActionRequestedName && this.__lastEmActionRequestedName == aEventType)
gYaSearchService.resetPref(this.CHECK_TOOLBAR_COLLAPSED_PREF_NAME);
break;
default:
break;
}

this.__installed = ! (aEventType == "onUninstalling");
this.__lastEmActionRequestedName = aEventType;
}
,
observe: function YaInstaller_observe(aSubject, aTopic, aData) {
switch (aTopic) {
case this.APP_ACTION_QUIT_TOPIC:
this.shutdown();
break;
default:
break;
}

}
,
_proccessInstall: function YaInstaller__proccessInstall() {
var currentVersion = gYaSearchService.barExtensionMajorVersion;
var lastVersion = gYaSearchService.getCharPref(this.LASTVERSION_PREF_NAME);
this._checkToolbarCollapsed(lastVersion,currentVersion);
if (lastVersion == currentVersion)
return;
gYaSearchService.setCharPref(this.LASTVERSION_PREF_NAME,currentVersion);
const versionComparator = Cc["@mozilla.org/xpcom/version-comparator;1"].getService(Ci.nsIVersionComparator);
if (lastVersion == "0")
{
if (typeof gYaOverlay == "object")
{
if ("setNavBarIconSizeToSmall" in gYaOverlay && gYaSearchService.isYandexFirefoxDistribution)
gYaOverlay.setNavBarIconSizeToSmall();
}

this._changePreferencesOnInstall();
}
 else
{
try {
if (typeof gYaOverlay === "object" && "migrateWidgets" in gYaOverlay)
gYaOverlay.migrateWidgets(lastVersion);
}
catch (e) {
gYaSearchService.log(e);
}

}

try {
this._setPersonasTheme();
}
catch (e) {
Cu.reportError(e);
}

}
,
_checkToolbarCollapsed: function YaInstaller__checkToolbarCollapsed(aLastVersion, aCurrentVersion) {
var checkToolbarCollapsed = gYaSearchService.getIntPref(this.CHECK_TOOLBAR_COLLAPSED_PREF_NAME);
if (checkToolbarCollapsed)
{
gYaSearchService.resetPref(this.CHECK_TOOLBAR_COLLAPSED_PREF_NAME);
if (checkToolbarCollapsed == 1 && typeof gYaOverlay === "object" && "setToolbarCollapsedState" in gYaOverlay)
{
if (aLastVersion == "0" || aLastVersion === aCurrentVersion)
{
gYaOverlay.setToolbarCollapsedState(false);
}

}

}

}
,
_changePreferencesOnInstall: function YaInstaller__changePreferencesOnInstall() {

}
,
_setPersonasTheme: function YaInstaller__setPersonasTheme() {
var profileDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD",Ci.nsIFile);
var personasDir = gYaSearchService.getInstallDir();
personasDir.append("defaults");
personasDir.append("personas-skin");
if (! (personasDir.exists() && personasDir.isDirectory()))
return;
var lwtDataFile = personasDir.clone();
lwtDataFile.append("data.json");
var lwtData;
try {
lwtData = JSON.parse(gYaSearchService.readFile(lwtDataFile));
}
catch (e) {

}

if (! (lwtData && lwtData.id))
return;
["installDate", "updateDate"].forEach(function (datePropName) {
if (datePropName in lwtData)
lwtData[datePropName] = Date.now();
}
);
["header", "footer"].forEach(function (imageType) {
var file = personasDir.clone();
file.append(imageType + ".jpg");
if (file.exists() && file.isFile())
{
let name = "eco-personas-" + imageType + ".jpg";
try {
file.copyTo(profileDir,name);
}
catch (e) {
Cu.reportError(e);
}

let fileCopy = profileDir.clone();
fileCopy.append(name);
if (fileCopy.exists() && fileCopy.isFile())
{
try {
let uri = IO_SERVICE.newFileURI(fileCopy);
if (uri)
lwtData[imageType + "URL"] = uri.spec;
}
catch (e) {

}

}

}

}
);
var tempScope = {
};
Cu.import("resource://gre/modules/LightweightThemeManager.jsm",tempScope);
var lwtManager = tempScope.LightweightThemeManager;
var currentTheme = lwtManager.currentTheme;
lwtManager.setLocalTheme(lwtData);
}
,
STT_PREF_NAME: "yasearch.general.stt",
get sttInstall() {
var stt = gYaSearchService.getCharPref(this.STT_PREF_NAME);
return stt !== "{\"s\":{\"i\":4}}";
}
,
set sttInstall(aValue) {
gYaSearchService.setCharPref(this.STT_PREF_NAME,"{\"s\":{\"i\":4}}");
}
,
_proccessUninstall: function YaInstaller__proccessUninstall() {
gYaSearchService.resetPref(this.LASTVERSION_PREF_NAME);
gYaSearchService.resetPref("yasearch.license.accepted");
gYaSearchService.resetPref("yasearch.welcomepage.version.introduced");
gYaSearchService.resetPref("yasearch.guid.clids.creationDate");
gYaSearchService.resetPref(this.STT_PREF_NAME);
var vendorFileName = gYaSearchService.vendorFileName;
gYaSearchService.resetPref("yasearch.general.app.bar.type");
if (typeof gYaStorage === "object" && "shutdown" in gYaStorage)
gYaStorage.shutdown();
try {
gYaSearchService.yaAuth.PasswordManager.removeAllUsersData();
}
catch (ex) {

}

var asyncModule = gYaSearchService.customBarApp.core.Lib.async;
var yandexDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD",Ci.nsIFile);
yandexDir.append("yandex");
if (yandexDir.exists())
{
["cities.data.xml", "regions.data.xml", "services.mybar.xml", "maps.data.xml", "services.data.xml", "ftab.data.xml", "yasearch-storage.sqlite", "bar-logo.ico", "ftab-data", "users.sqlite"].forEach(function (aFileOrDirectoryName) {
var fileToRemove = yandexDir.clone();
fileToRemove.append(aFileOrDirectoryName);
try {
asyncModule.nextTick(function () {
gYaSearchService.removeFile(fileToRemove);
}
);
}
catch (e) {
Cu.reportError(e);
}

}
);
asyncModule.nextTick(function () {
if (! yandexDir.directoryEntries.hasMoreElements())
{
try {
gYaSearchService.removeFile(yandexDir);
}
catch (e) {
Cu.reportError(e);
}

}

}
);
}

}
};
gSubscriptsForInit.push(gYaInstaller);
